'use strict';

goog.provide('Blockly.Python.music');
goog.require('Blockly.Python');

Blockly.Python.addReservedWords('music');

Blockly.Python['yolobit_music_play_built_in'] = function(block) {
  Blockly.Python.definitions_['import_music'] = 'import music';
  var dropdown_melody = block.getFieldValue('melody');
  var checkbox_wait = block.getFieldValue('wait') == 'TRUE' ? 'True' : 'False';
  var checkbox_loop = block.getFieldValue('loop') == 'TRUE' ? 'True' : 'False';
  var code = 'music.play(music.' + dropdown_melody +', wait=' + checkbox_wait + ', loop=' + checkbox_loop + ')\n';
  return code;
};

Blockly.Python['yolobit_music_pitch'] = function(block) {
  Blockly.Python.definitions_['import_music'] = 'import music';
  var number_pitch = Blockly.Python.valueToCode(block, 'pitch', Blockly.Python.ORDER_ATOMIC);
  var number_duration = Blockly.Python.valueToCode(block, 'duration', Blockly.Python.ORDER_ATOMIC);
  var code = 'music.pitch(' + number_pitch + ', ' + number_duration + ')\n';
  return code;
};

Blockly.Python['yolobit_music_note'] = function(block) {
  return [Blockly.FieldPitch.NOTES[parseInt(block.getFieldValue('PITCH'))], Blockly.Python.ORDER_ATOMIC];
};

Blockly.Python['yolobit_music_play_note'] = function(block) {
  Blockly.Python.definitions_['import_music'] = 'import music';
  //var dropdown_note = Blockly.FieldPitch.NOTES[parseInt(Blockly.Python.valueToCode(block, 'PITCH',
  //  Blockly.Python.ORDER_ATOMIC) || '7')];
  var dropdown_note = Blockly.Python.valueToCode(block, 'PITCH',
    Blockly.Python.ORDER_ATOMIC) || 'C5';
  var dropdown_beat = block.getFieldValue('DURATION');

  var code = "music.play(['" + dropdown_note + ":" + dropdown_beat + "'])\n";
  return code;
};

Blockly.Python['yolobit_music_rest'] = function(block) {
  var code = "music.play(['R:" + block.getFieldValue('DURATION') + "'])\n";
  return code;
};

Blockly.Python['yolobit_music_reset'] = function(block) {
  Blockly.Python.definitions_['import_music'] = 'import music';
  var code = 'music.reset()\n';
  return code;
};

Blockly.Python['yolobit_music_stop'] = function(block) {
  Blockly.Python.definitions_['import_music'] = 'import music';
  var code = 'music.stop()\n';
  return code;
};

Blockly.Python['yolobit_music_set_tempo'] = function(block) {
  Blockly.Python.definitions_['import_music'] = 'import music';
  var value_ticks = Blockly.Python.valueToCode(block, 'ticks', Blockly.Python.ORDER_ATOMIC);
  var value_bpm = Blockly.Python.valueToCode(block, 'bpm', Blockly.Python.ORDER_ATOMIC);
  var code = 'music.set_tempo(' + value_ticks + ', ' + value_bpm +')\n';
  return code;
};

Blockly.Python['yolobit_music_get_tempo'] = function(block) {
  Blockly.Python.definitions_['import_music'] = 'import music';
  var code = 'music.get_tempo()';
  return [code, Blockly.Python.ORDER_MEMBER];
};
