'use strict';

goog.provide('Blockly.Python.basic');
goog.require('Blockly.Python');

// Any imports need to be reserved words
Blockly.Python.addReservedWords('wifi');

Blockly.Python['yolobit_wifi_connect'] = function(block) {
  Blockly.Python.definitions_['import_wifi'] = 'from wifi import *';
  var value_wifi = Blockly.Python.valueToCode(block, 'WIFI', Blockly.Python.ORDER_ATOMIC);
  var value_password = Blockly.Python.valueToCode(block, 'PASSWORD', Blockly.Python.ORDER_ATOMIC);
  var value_name = Blockly.Python.valueToCode(block, 'NAME', Blockly.Python.ORDER_ATOMIC);
  // TODO: Assemble Python into code variable.
  var code = 'connect(' + value_wifi + ', ' + value_password + ', ' + value_name + ')\n';
  return code;
};

Blockly.Python['yolobit_wifi_check_message'] = function(block) {
  Blockly.Python.definitions_['import_wifi'] = 'from wifi import *';
  // TODO: Assemble Python into code variable.
  var code = 'check_message()\n';
  return code;
};

Blockly.Python['yolobit_wifi_send_message'] = function(block) {
  Blockly.Python.definitions_['import_wifi'] = 'from wifi import *';
  var value_message = Blockly.Python.valueToCode(block, 'MESSAGE', Blockly.Python.ORDER_ATOMIC);
  var value_name = Blockly.Python.valueToCode(block, 'NAME', Blockly.Python.ORDER_ATOMIC);
  // TODO: Assemble Python into code variable.
  var code = 'send_message(' + value_name + ', ' + value_message + ')\n';
  return code;
};

Blockly.Python['yolobit_wifi_log_data'] = function(block) {
  Blockly.Python.definitions_['import_wifi'] = 'from wifi import *';
  var value_data = Blockly.Python.valueToCode(block, 'DATA', Blockly.Python.ORDER_ATOMIC);
  var dropdown_channel = block.getFieldValue('CHANNEL');
  // TODO: Assemble Python into code variable.
  var code = 'log_data("' + dropdown_channel + '", ' + value_data + ')\n';
  return code;
};

Blockly.Python['yolobit_wifi_on_receive_message'] = function(block) {
  Blockly.Python.definitions_['import_wifi'] = 'from wifi import *';
  var variable_message = Blockly.Python.variableDB_.getName(block.getFieldValue('message'), Blockly.Variables.NAME_TYPE);
  var statements_action = Blockly.Python.statementToCode(block, 'ACTION');
  // TODO: Assemble Python into code variable.
  var cbFunctionName = Blockly.Python.provideFunction_(
    'on_message_receive_callback_' + block.id,
    ['def ' + Blockly.Python.FUNCTION_NAME_PLACEHOLDER_ + '(' + variable_message + '):',
      statements_action || Blockly.Python.PASS
    ]);
  
  var code = 'on_receive_message("", ' + cbFunctionName + ')\n';
  return code;
};

Blockly.Python['yolobit_wifi_on_receive_message_from_dashboard'] = function(block) {
  Blockly.Python.definitions_['import_wifi'] = 'from wifi import *';
  var variable_message = Blockly.Python.variableDB_.getName(block.getFieldValue('message'), Blockly.Variables.NAME_TYPE);
  var dropdown_channel = block.getFieldValue('CHANNEL');
  var statements_action = Blockly.Python.statementToCode(block, 'ACTION');
  // TODO: Assemble Python into code variable.
  var cbFunctionName = Blockly.Python.provideFunction_(
    'on_message_receive_callback_' + block.id,
    ['def ' + Blockly.Python.FUNCTION_NAME_PLACEHOLDER_ + '(' + variable_message + '):',
      statements_action || Blockly.Python.PASS
    ]);
  
  var code = 'on_receive_message("' + dropdown_channel + '", ' + cbFunctionName + ')\n';
  return code;
};
